#
# Perl Script um eine LOD-Datei in einen Assembler-Include umzuwandeln
# erstellt von Thomas Mller fr C-Header-Dateinen
# Anpassung von Jan Alte an Assembler-Include-Dateien + Vereinfachungen
#
$EIN = $ARGV[0];

open EIN or die "can't open $EIN";

$adr = 0;
while(<EIN>)
    {
    if ($modus == 0)
        {
        next unless /^_DATA/;
        }

    if (/^_DATA/)
        {
        $modus = 1;
        ($a, $b, $addr) = split;
        $addr = 3 * hex($addr);
        next;
        }

    if (/^_SYMBOL/ || /^_END/)
        {
        $modus = 0;
        next;
        }

    (@a) = split;

    for ($i = 0; $i < 8; $i++)
        {
        if ($a[$i] eq undef)
            {
            last;
            }

        $h = hex(substr($a[$i], 0, 2));
        $m = hex(substr($a[$i], 2, 2));
        $l = hex(substr($a[$i], 4, 2));

        $dsp[$addr++] = $h;
        $dsp[$addr++] = $m;
        $dsp[$addr++] = $l;
        }
    }

#
# Ausgabe
#

printf "DSPPrg	db ", $ARGV[0];
$anz = 0;
for ($i = 0; $i < $addr-1; $i++) {
 $anz++;
 printf "%.3xh,", $dsp[$i];
 if ((($anz % 12) == 0) && ($i < ($addr - 1))) {
   printf "\n	db ";
 }
}
printf "%.3xh\n", $dsp[$i];
printf "DSPSize	EQU  %d\n", $addr / 3;
